--
-- ocp_components_pkg.vhd
-- Package Header of ADPKGOCP Library
--
-- (C) 2008-2009 Alpha Data Ltd.
--
-- OCP AD components Package
--
-- Component Defintions for AD OCP PACKAGE
--
-- Basic Components


library ieee;
use ieee.std_logic_1164.all;

library work;
use work.ocpad.all;

package ocpad_components is

  component multiport_ocp_if2_b32
    generic (
      round_robin_arb : boolean := false;
      use_timeout  : boolean := false;
      timeout_bits : integer := 16);
    port(
      ocp_m2s_memif : out ocpad_burst32_m2sT;
      ocp_s2m_memif : in  ocpad_burst32_s2mT;
      ocp_m2s0 : in  ocpad_burst32_m2sT;
      ocp_s2m0 : out ocpad_burst32_s2mT;
      ocp_m2s1 : in  ocpad_burst32_m2sT;
      ocp_s2m1 : out ocpad_burst32_s2mT;
      status   : out std_logic_vector(3 downto 0);
      clk : in std_logic);
  end component;

  component multiport_ocp_if2_b64
    generic (
      round_robin_arb : boolean := false;
      use_timeout  : boolean := false;
      timeout_bits : integer := 16);
    port(
      ocp_m2s_memif : out ocpad_burst64_m2sT;
      ocp_s2m_memif : in  ocpad_burst64_s2mT;
      ocp_m2s0 : in  ocpad_burst64_m2sT;
      ocp_s2m0 : out ocpad_burst64_s2mT;
      ocp_m2s1 : in  ocpad_burst64_m2sT;
      ocp_s2m1 : out ocpad_burst64_s2mT;
      status   : out std_logic_vector(3 downto 0);
      clk : in std_logic);
  end component;

  component multiport_ocp_if2_b128
    generic (
      round_robin_arb : boolean := false;
      use_timeout  : boolean := false;
      timeout_bits : integer := 16);
    port(
      ocp_m2s_memif : out ocpad_burst128_m2sT;
      ocp_s2m_memif : in  ocpad_burst128_s2mT;
      ocp_m2s0 : in  ocpad_burst128_m2sT;
      ocp_s2m0 : out ocpad_burst128_s2mT;
      ocp_m2s1 : in  ocpad_burst128_m2sT;
      ocp_s2m1 : out ocpad_burst128_s2mT;
      status   : out std_logic_vector(3 downto 0);
      clk : in std_logic);
  end component;

  component multiport_ocp_if3_b32
    generic (
      round_robin_arb : boolean := false;
      use_timeout  : boolean := false;
      timeout_bits : integer := 16);
    port(
      ocp_m2s_memif : out ocpad_burst32_m2sT;
      ocp_s2m_memif : in  ocpad_burst32_s2mT;
      ocp_m2s0 : in  ocpad_burst32_m2sT;
      ocp_s2m0 : out ocpad_burst32_s2mT;
      ocp_m2s1 : in  ocpad_burst32_m2sT;
      ocp_s2m1 : out ocpad_burst32_s2mT;
      ocp_m2s2 : in  ocpad_burst32_m2sT;
      ocp_s2m2 : out ocpad_burst32_s2mT;
      status   : out std_logic_vector(3 downto 0);
      clk : in std_logic);
  end component;

  component multiport_ocp_if3_b64
    generic (
      round_robin_arb : boolean := false;
      use_timeout  : boolean := false;
      timeout_bits : integer := 16);
    port(
      ocp_m2s_memif : out ocpad_burst64_m2sT;
      ocp_s2m_memif : in  ocpad_burst64_s2mT;
      ocp_m2s0 : in  ocpad_burst64_m2sT;
      ocp_s2m0 : out ocpad_burst64_s2mT;
      ocp_m2s1 : in  ocpad_burst64_m2sT;
      ocp_s2m1 : out ocpad_burst64_s2mT;
      ocp_m2s2 : in  ocpad_burst64_m2sT;
      ocp_s2m2 : out ocpad_burst64_s2mT;
      status   : out std_logic_vector(3 downto 0);
      clk : in std_logic);
  end component;

  component multiport_ocp_if3_b128
    generic (
      round_robin_arb : boolean := false;
      use_timeout  : boolean := false;
      timeout_bits : integer := 16);
    port(
      ocp_m2s_memif : out ocpad_burst128_m2sT;
      ocp_s2m_memif : in  ocpad_burst128_s2mT;
      ocp_m2s0 : in  ocpad_burst128_m2sT;
      ocp_s2m0 : out ocpad_burst128_s2mT;
      ocp_m2s1 : in  ocpad_burst128_m2sT;
      ocp_s2m1 : out ocpad_burst128_s2mT;
      ocp_m2s2 : in  ocpad_burst128_m2sT;
      ocp_s2m2 : out ocpad_burst128_s2mT;
      status   : out std_logic_vector(3 downto 0);
      clk : in std_logic);
  end component;

  component multiport_ocp_if4_b32
    generic (
      round_robin_arb : boolean := false;
      use_timeout  : boolean := false;
      timeout_bits : integer := 16);
    port(
      ocp_m2s_memif : out ocpad_burst32_m2sT;
      ocp_s2m_memif : in  ocpad_burst32_s2mT;
      ocp_m2s0 : in  ocpad_burst32_m2sT;
      ocp_s2m0 : out ocpad_burst32_s2mT;
      ocp_m2s1 : in  ocpad_burst32_m2sT;
      ocp_s2m1 : out ocpad_burst32_s2mT;
      ocp_m2s2 : in  ocpad_burst32_m2sT;
      ocp_s2m2 : out ocpad_burst32_s2mT;
      ocp_m2s3 : in  ocpad_burst32_m2sT;
      ocp_s2m3 : out ocpad_burst32_s2mT;
      status   : out std_logic_vector(3 downto 0);
      clk : in std_logic);
  end component;

  component multiport_ocp_if4_b64
    generic (
      round_robin_arb : boolean := false;
      use_timeout  : boolean := false;
      timeout_bits : integer := 16);
    port(
      ocp_m2s_memif : out ocpad_burst64_m2sT;
      ocp_s2m_memif : in  ocpad_burst64_s2mT;
      ocp_m2s0 : in  ocpad_burst64_m2sT;
      ocp_s2m0 : out ocpad_burst64_s2mT;
      ocp_m2s1 : in  ocpad_burst64_m2sT;
      ocp_s2m1 : out ocpad_burst64_s2mT;
      ocp_m2s2 : in  ocpad_burst64_m2sT;
      ocp_s2m2 : out ocpad_burst64_s2mT;
      ocp_m2s3 : in  ocpad_burst64_m2sT;
      ocp_s2m3 : out ocpad_burst64_s2mT;
      status   : out std_logic_vector(3 downto 0);
      clk : in std_logic);
  end component;

  component multiport_ocp_if4_b128
    generic (
      round_robin_arb : boolean := false;
      use_timeout  : boolean := false;
      timeout_bits : integer := 16);
    port(
      ocp_m2s_memif : out ocpad_burst128_m2sT;
      ocp_s2m_memif : in  ocpad_burst128_s2mT;
      ocp_m2s0 : in  ocpad_burst128_m2sT;
      ocp_s2m0 : out ocpad_burst128_s2mT;
      ocp_m2s1 : in  ocpad_burst128_m2sT;
      ocp_s2m1 : out ocpad_burst128_s2mT;
      ocp_m2s2 : in  ocpad_burst128_m2sT;
      ocp_s2m2 : out ocpad_burst128_s2mT;
      ocp_m2s3 : in  ocpad_burst128_m2sT;
      ocp_s2m3 : out ocpad_burst128_s2mT;
      status   : out std_logic_vector(3 downto 0);
      clk : in std_logic);
  end component;


  component ocp_chipscope32
    port(
      ocp_m2s : in ocpad_burst32_m2sT;
      ocp_s2m : in ocpad_burst32_s2mT;
      clk : in std_logic);
  end component;

  component ocp_chipscope64
    port(
      ocp_m2s : in ocpad_burst64_m2sT;
      ocp_s2m : in ocpad_burst64_s2mT;
      clk : in std_logic);
  end component;

  component ocp_chipscope128
    port(
      ocp_m2s : in ocpad_burst128_m2sT;
      ocp_s2m : in ocpad_burst128_s2mT;
      clk : in std_logic);
  end component;


  component ocp_demux_b32
    generic (
      number_of_slaves  : integer := 2;
      demux_address_lsb : integer := 16);
    port(
      clk : in std_logic;
      master_m2s : in ocpad_burst32_m2sT;
      master_s2m : out  ocpad_burst32_s2mT;
      slaves_m2s : out ocpad_burst32_m2sT_array(0 to number_of_slaves-1);
      slaves_s2m : in  ocpad_burst32_s2mT_array(0 to number_of_slaves-1));
  end component;

  component ocp_demux_b64
    generic (
      number_of_slaves  : integer := 2;
      demux_address_lsb : integer := 16);
    port(
      clk : in std_logic;
      master_m2s : in ocpad_burst64_m2sT;
      master_s2m : out  ocpad_burst64_s2mT;
      slaves_m2s : out ocpad_burst64_m2sT_array(0 to number_of_slaves-1);
      slaves_s2m : in  ocpad_burst64_s2mT_array(0 to number_of_slaves-1));
  end component;

  component ocp_demux_b128
    generic (
      number_of_slaves  : integer := 2;
      demux_address_lsb : integer := 16);
    port(
      clk : in std_logic;
      master_m2s : in ocpad_burst128_m2sT;
      master_s2m : out  ocpad_burst128_s2mT;
      slaves_m2s : out ocpad_burst128_m2sT_array(0 to number_of_slaves-1);
      slaves_s2m : in  ocpad_burst128_s2mT_array(0 to number_of_slaves-1));
  end component;

  component ocp_demux_r32
    generic (
      number_of_slaves  : integer := 2;
      demux_address_lsb : integer := 16);
    port(
      clk : in std_logic;
      master_m2s : in ocpad_register32_m2sT;
      master_s2m : out  ocpad_register32_s2mT;
      slaves_m2s : out ocpad_register32_m2sT_array(0 to number_of_slaves-1);
      slaves_s2m : in  ocpad_register32_s2mT_array(0 to number_of_slaves-1));
  end component;

  component ocp_demux_r64
    generic (
      number_of_slaves  : integer := 2;
      demux_address_lsb : integer := 16);
    port(
      clk : in std_logic;
      master_m2s : in ocpad_register64_m2sT;
      master_s2m : out  ocpad_register64_s2mT;
      slaves_m2s : out ocpad_register64_m2sT_array(0 to number_of_slaves-1);
      slaves_s2m : in  ocpad_register64_s2mT_array(0 to number_of_slaves-1));
  end component;


  component ocp_dummy_target32
    port (
      ocp_clk : in std_logic;
      ocp_m2s : in ocpad_burst32_m2sT;
      ocp_s2m : out ocpad_burst32_s2mT);
  end component;

  component ocp_dummy_target64
    port (
      ocp_clk : in std_logic;
      ocp_m2s : in ocpad_burst64_m2sT;
      ocp_s2m : out ocpad_burst64_s2mT);
  end component;

  component ocp_dummy_target128
    port (
      ocp_clk : in std_logic;
      ocp_m2s : in ocpad_burst128_m2sT;
      ocp_s2m : out ocpad_burst128_s2mT);
  end component;

  component ocp_slave_interface64
    generic (
      read_latency : integer := 1);
    port (
      -- OCP Interface
      ocp_clk : in std_logic;
      ocp_rst : in std_logic;
      ocp_m2s : in ocpad_register64_m2sT;
      ocp_s2m : out ocpad_register64_s2mT;
      -- simple bus interface
      simple_bus_addr : out std_logic_vector(21 downto 0);
      simple_bus_write : out std_logic;
      simple_bus_read : out std_logic;
      simple_bus_wdata : out std_logic_vector(31 downto 0);
      simple_bus_rdata : in std_Logic_vector(31 downto 0)
      );
  end component;

  component ocp_slave_interface32
    generic (
      read_latency : integer := 1);
    port (
      -- OCP Interface
      ocp_clk : in std_logic;
      ocp_rst : in std_logic;
      ocp_m2s : in ocpad_register32_m2sT;
      ocp_s2m : out ocpad_register32_s2mT;
      -- simple bus interface
      simple_bus_addr : out std_logic_vector(21 downto 0);
      simple_bus_write : out std_logic;
      simple_bus_read : out std_logic;
      simple_bus_wdata : out std_logic_vector(31 downto 0);
      simple_bus_rdata : in std_Logic_vector(31 downto 0)
      );
  end component;
  
  component ocp_monitor_b32r32
    port (
      -- Interface to OCP Burst Profile
      burst_clk : in  std_logic;
      burst_m2s : in  ocpad_burst32_m2sT;
      burst_s2m : in  ocpad_burst32_s2mT;
      -- Interface to OCP Register Profile
      reg_clk  : in  std_logic;
      reg_m2s  : in  ocpad_register32_m2sT;
      reg_s2m  : out ocpad_register32_s2mT;
      -- Debug Data Inputs
      debug    : in  std_logic_vector(63 downto 0));
  end component;
  component ocp_monitor_b64r32
    port (
      -- Interface to OCP Burst Profile
      burst_clk : in  std_logic;
      burst_m2s : in  ocpad_burst64_m2sT;
      burst_s2m : in  ocpad_burst64_s2mT;
      -- Interface to OCP Register Profile
      reg_clk  : in  std_logic;
      reg_m2s  : in  ocpad_register32_m2sT;
      reg_s2m  : out ocpad_register32_s2mT;
      -- Debug Data Inputs
      debug    : in  std_logic_vector(63 downto 0));
  end component;
  component ocp_monitor_b128r32
    port (
      -- Interface to OCP Burst Profile
      burst_clk : in  std_logic;
      burst_m2s : in  ocpad_burst128_m2sT;
      burst_s2m : in  ocpad_burst128_s2mT;
      -- Interface to OCP Register Profile
      reg_clk  : in  std_logic;
      reg_m2s  : in  ocpad_register32_m2sT;
      reg_s2m  : out ocpad_register32_s2mT;
      -- Debug Data Inputs
      debug    : in  std_logic_vector(127 downto 0));
  end component;
  component ocp_monitor_b32r64
    port (
      -- Interface to OCP Burst Profile
      burst_clk : in  std_logic;
      burst_m2s : in  ocpad_burst32_m2sT;
      burst_s2m : in  ocpad_burst32_s2mT;
      -- Interface to OCP Register Profile
      reg_clk  : in  std_logic;
      reg_m2s  : in  ocpad_register64_m2sT;
      reg_s2m  : out ocpad_register64_s2mT;
      -- Debug Data Inputs
      debug    : in  std_logic_vector(63 downto 0));
  end component;
  component ocp_monitor_b64r64
    port (
      -- Interface to OCP Burst Profile
      burst_clk : in  std_logic;
      burst_m2s : in  ocpad_burst64_m2sT;
      burst_s2m : in  ocpad_burst64_s2mT;
      -- Interface to OCP Register Profile
      reg_clk  : in  std_logic;
      reg_m2s  : in  ocpad_register64_m2sT;
      reg_s2m  : out ocpad_register64_s2mT;
      -- Debug Data Inputs
      debug    : in  std_logic_vector(63 downto 0));
  end component;
  component ocp_monitor_b128r64
    port (
      -- Interface to OCP Burst Profile
      burst_clk : in  std_logic;
      burst_m2s : in  ocpad_burst128_m2sT;
      burst_s2m : in  ocpad_burst128_s2mT;
      -- Interface to OCP Register Profile
      reg_clk  : in  std_logic;
      reg_m2s  : in  ocpad_register64_m2sT;
      reg_s2m  : out ocpad_register64_s2mT;
      -- Debug Data Inputs
      debug    : in  std_logic_vector(127 downto 0));
  end component;


 
  
end ocpad_components;
