--
-- fifo_if_types_b32.vhd
-- Header Package of ADPKGOCP Library
--
-- (C) 2007-2009 Alpha Data Ltd.
--
-- fifo_if_types
--
-- Interfacing types for FIFOs

library IEEE;
use IEEE.std_logic_1164.all;

package fifo_if_types is

  type fifo_read_port_inputs_type is record
    rd : std_logic;
  end record;

  type fifo_read_port_outputs_type is record
    data : std_logic_vector(31 downto 0);
    empty : std_logic;
    nempty : std_logic;
    level : std_logic_vector(15 downto 0);
  end record;

  type fifo_write_port_inputs_type is record
    wr : std_logic;
    data : std_logic_vector(31 downto 0);
  end record;

  type fifo_write_port_outputs_type is record
    full : std_logic;
    nfull : std_logic;
    level : std_logic_vector(15 downto 0);
  end record;
 
  constant fifo_write_port_inputs_default : fifo_write_port_inputs_type := ( wr => '0', data => ( others => '-' ) );
  constant fifo_read_port_inputs_default : fifo_read_port_inputs_type := ( rd => '0' ); 

end fifo_if_types;
