/*
  OCPSINK.H


*/
#ifndef OCPSINK_H

#include "lb2ocp.h"

#define OCPSINK_H

typedef enum {
  OCPSINK_START_ADDR=0,
  OCPSINK_WORD_LIMIT=1,
  OCPSINK_IRQ_LIMIT=2,
  OCPSINK_CONTROL=3,
  OCPSINK_CURRENT_ADDR=4,
  OCPSINK_CURRENT_WCOUNT=5,
  OCPSINK_CURRENT_ICOUNT=6
} OCPSINK_REG_ADDRESS;

typedef struct _OCPSINK {
 
  volatile DWORD *fpgaSpace;
  unsigned int burst_engine;
  unsigned int burst_target;
  unsigned int reg_bank; 
  unsigned int irq_mask; 
  unsigned int use64bit; 
  
} OCPSINK;

typedef OCPSINK* POCPSINK;

POCPSINK OCPSINK_Create(PLB2OCP bridge, 
                        unsigned int burst_engine,
                        unsigned int burst_target,
                        unsigned int reg_bank,
                        unsigned int reg_offset,
                        unsigned int irq_mask,
                        unsigned int use64bit);
                                                     
void OCPSINK_Destroy(POCPSINK sink);

int OCPSINK_StartCapture(POCPSINK sink, 
                          unsigned int start_addr,
                          unsigned int word_limit,
                          unsigned int irq_limit,
                          unsigned int continuous);
                          
void OCPSINK_HaltContinuous(POCPSINK sink);

void OCPSINK_Clear(POCPSINK sink);                          
int OCPSINK_IsRunning(POCPSINK sink);
unsigned int OCPSINK_GetCurrentAddress(POCPSINK sink);
unsigned int OCPSINK_GetCurrentDataCount(POCPSINK sink);
unsigned int OCPSINK_GetCurrentIntCount(POCPSINK sink);


#endif